EDIT - feature request #8136

Implement sources for type designations in TaxEditor
02/24/2019 01:04 PM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.6

Severity: normal

Description

For details see #8017.

Be aware that there are 2 different types of sources "lectotype" sources and general sources. "Lectotype" source is exactly 1 source
which should only be available for type designations with a status returning true on isLectotype().

implemented:
® sources in supplemental data view

¢ reference for lectotypes
¢ update type section when changing type to lectotype or from lectotype

Related issues:

Related to EDIT - feature request #7653: [DISCUSS] Delete NameFacts => Resullt... Closed
Related to EDIT - feature request #8137: Implement sources for type designati... Feedback
Related to EDIT - feature request #8135: Implement verbatim type information ... Closed
Related to EDIT - bug #8140: Update list of type designation status which all... Closed
Related to EDIT - feature request #8139: [Rule] Validate lectotype sources Resolved
Related to EDIT - feature request #6413: [DISCUSS] How to create type duplica... Closed
Blocked by EDIT - feature request #8017: TypeDesignations need sources additi... Closed

Associated revisions

Revision 341ee745 - 02/26/2019 11:33 AM - Katja Luther

adadpt editor to changes in TypeDesignationBase

Revision 87934a59 - 02/27/2019 12:10 PM - Katja Luther

ref #8136: move sources to supplemental data

Revision 89084783 - 02/27/2019 01:53 PM - Katja Luther
ref #8136: add reference part for lectotype

Revision 9f40979f - 03/12/2019 09:30 AM - Katja Luther

fix #8136: update type section when changing type to or from lectotype

Revision 6bf65877 - 04/03/2019 02:51 PM - Katja Luther

ref #8136: save citation of typeDesignation

Revision 03a2b1f4 - 04/03/2019 03:57 PM - Patrick Plitzner

ref #8136 Show micro citation in details view

Revision 310480f4 - 04/04/2019 11:09 AM - Katja Luther

ref #8136: remove citation if changed away from lectotype

Revision b0ed30f0 - 04/05/2019 12:17 PM - Katja Luther

ref #8136: add warning message when changing type away from lectotype and citation exist
Revision 09015fb4 - 04/05/2019 12:46 PM - Katja Luther

ref #8136: externalization

Revision 63878e5a - 04/05/2019 01:26 PM - Katja Luther

ref #8136: externalization

Revision 46d9527b - 04/08/2019 12:25 PM - Andreas Miiller

ref #8136 slightly changed lectotype reference removal warning

Revision a53422d5 - 04/08/2019 01:46 PM - Katja Luther
ref #8136: fix handling if status is set to null

Revision c3cad351 - 04/11/2019 09:24 AM - Katja Luther
ref #8136: label issues

Revision e5d18094 - 04/11/2019 10:09 AM - Katja Luther

ref #8136: move not designated checkbox

Revision 9e150d47 - 04/11/2019 11:10 AM - Katja Luther

ref #8136: shorter reference detail label

History

#1 - 02/24/2019 01:04 PM - Andreas Miiller

- Blocked by feature request #8017: TypeDesignations need sources additional to lectotypifcation sources added

#2 - 02/24/2019 01:04 PM - Andreas Miiller
- Related to feature request #7653: [DISCUSS] Delete NameFacts => Result: no added

#3 - 02/24/2019 01:07 PM - Andreas Miiller
- Description updated

#4 - 02/24/2019 01:11 PM - Andreas Miiller

- Related to feature request #8137: Implement sources for type designations in data portal added

#5 - 02/24/2019 01:13 PM - Andreas Miiller

- Related to feature request #8135: Implement verbatim type information in TaxEditor added

#6 - 02/25/2019 02:32 PM - Andreas Miiller
- Related to bug #8140: Update list of type designation status which allow an explicit source added

#7 - 02/25/2019 02:33 PM - Andreas Miiller
- Related to feature request #8139: [Rule] Validate lectotype sources added

#8 - 02/25/2019 04:48 PM - Andreas Miiller
- Related to feature request #6413: [DISCUSS] How to create type duplicates (e.g. isotypes) for a taxon name added

#9 - 02/27/2019 01:56 PM - Katja Luther
- Description updated

- Status changed from New to In Progress

#10 - 02/27/2019 01:57 PM - Katja Luther

- Description updated

#11 - 03/04/2019 11:35 AM - Katja Luther
- Priority changed from New to Highest
#12 - 03/12/2019 09:30 AM - Katja Luther
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|9f40979f5e0d2fc55100acc5a7fabac00d48ce12.

#13 - 03/12/2019 09:31 AM - Katja Luther
- Description updated
- Assignee changed from Katja Luther to Andreas Miiller

- % Done changed from 50 to 0
please review

#14 - 03/12/2019 09:32 AM - Katja Luther

- Description updated

#15 - 04/01/2019 03:59 PM - Katja Luther

- Assignee changed from Andreas Muiller to Patrick Plitzner

#16 - 04/03/2019 04:39 PM - Patrick Plitzner

- Assignee changed from Patrick Plitzner to Andreas Mliller

- % Done changed from 0 to 50

tested on nightly.

Changing to any *lectotype will show the reference related elements. The reference and the details are saved correctly.

Only issue: When changing from *lectotype which already has a reference to any non-lectotype, saving and then changing back to *lectotype the
reference is still connected to this type designation. This may be a feature and not a bug.

#17 - 04/04/2019 10:55 AM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther
Patrick Plitzner wrote:
tested on nightly.
Changing to any *lectotype will show the reference related elements. The reference and the details are saved correctly.
Only issue: When changing from *lectotype which already has a reference to any non-lectotype, saving and then changing back to *lectotype the
reference is still connected to this type designation. This may be a feature and not a bug.
No, I don't think this is a feature. We should handle these type changes consistently. Changing nomenclatural code might be a template. There, if you

change the code, and an existing information is deleted this way you get a warning and you have to agree explicitly. The same should happen here.

By the way, changing the rank does not give the same warning, e.g. change species to genus the specific epithet is still stored. This to me does not
seem to be correct.

#18 - 04/04/2019 11:06 AM - Katja Luther
Andreas Muller wrote:
Patrick Plitzner wrote:
tested on nightly.
Changing to any *lectotype will show the reference related elements. The reference and the details are saved correctly.

Only issue: When changing from *lectotype which already has a reference to any non-lectotype, saving and then changing back to
*lectotype the reference is still connected to this type designation. This may be a feature and not a bug.
No, | don't think this is a feature. We should handle these type changes consistently. Changing nomenclatural code might be a template. There,
if you change the code, and an existing information is deleted this way you get a warning and you have to agree explicitly. The same should
happen here.

By the way, changing the rank does not give the same warning, e.g. change species to genus the specific epithet is still stored. This to me does
not seem to be correct.

But maybe this should be handled in the library? When updating a typedesignation check whether it has a reference but is not of type lectotype? At
the moment maybe it is easier to implement it in the editor but in general | would think it is better to check this while saving.

#19 - 04/04/2019 11:29 AM - Andreas Muller

Katja Luther wrote:

But maybe this should be handled in the library? When updating a typedesignation check whether it has a reference but is not of type lectotype?
At the moment maybe it is easier to implement it in the editor but in general | would think it is better to check this while saving.

The warning needs to be implemented in Ul | think. Or do you think about throwing an exception. Additionally we could add a validation rule.
Hardcoding to delete the reference if it is not a "lectotype” reference to me feels a bit to strict, but not sure about it.

#20 - 04/05/2019 08:55 AM - Katja Luther

Andreas Miller wrote:
Katja Luther wrote:

But maybe this should be handled in the library? When updating a typedesignation check whether it has a reference but is not of type
lectotype? At the moment maybe it is easier to implement it in the editor but in general | would think it is better to check this while saving.

The warning needs to be implemented in Ul | think. Or do you think about throwing an exception. Additionally we could add a validation rule.
Hardcoding to delete the reference if it is not a "lectotype” reference to me feels a bit to strict, but not sure about it.

I would think this should be handled by a validation rule. But for this release the editor removes the reference.

#21 - 04/05/2019 09:03 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Patrick Plitzner

#22 - 04/05/2019 09:19 AM - Patrick Plitzner

- Assignee changed from Patrick Plitzner to Andreas Miiller
Tested on nightly: The reference of any *lectotype is removed when switching the designation status to any non-lectotype.

#23 - 04/05/2019 11:10 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

To be honest, simply removing the reference is not my preferred solution. Is there a reason why we can't do like with the nomCode changes with a

warning that the reference will be deleted? Especially if someone accidentally changes the category this will prevent from unwanted data loss. Also
users may misuse the reference for ordinary type designation sources (definetely such data exists as sources where not available in the past). Also
here it might be easy that data is simply lost instead of being moved to the correct place. With a warning users have to think about the correct place
for their sources.

Also | don't think this will slow down the workflow as it will not happen very often that data has a source attached but is changed to a non-lectotype
category. But if it happens it is definetely worth thinking about if it is correct to simply delete the source.

#24 - 04/05/2019 11:19 AM - Andreas Miiller

Validation already exists by the way #8139 but needs validation framework in place to be available

#25 - 04/05/2019 12:20 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller
now there is a message asking if the user really wants to change the type away from lectotype when a citation exist.

#26 - 04/05/2019 12:20 PM - Katja Luther
- Assignee changed from Andreas Miiller to Katja Luther
Katja Luther wrote:

now there is a message asking if the user really wants to change the type away from lectotype when a citation exist.

translation is missing...

#27 - 04/05/2019 12:47 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

#28 - 04/08/2019 12:42 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 50 to 100

If Status is completely deleted the reference is not deleted but should (similar to choosing e.g. holotype) | guess.

Also "Not designated" should be moved elsewhere to keep status and it's reference close together. Mabe we can move it down after Reference Detall
as it is not used often. (Note: we also need to check if "Not Designated" excludes other fields from being filled than we should show fields only if "not
designated" is false. But this needs further investigation)

It would be nice to have a more specific label for reference and reference detail to make clear that it is ONLY for lectotypification. But as it is not only
for "lecto” but also for e.g. "neo" | am not sure what label to use. Maybe "Status Reference"? Any other ideas.

#29 - 04/08/2019 12:50 PM - Andreas Miiller
- % Done changed from 100 to 70

After choosing a specimen for the type designation it is sometimes impossible to select the type designation to show the supplemental data for the
type designation. One needs to set the focus to something else (e.g. the taxon in name editor) and try to select the type designation again. Also the
later does not always work but difficult to reproduce.

Does someone else have the same experience? If yes, it should be fixed because otherwise it is difficult and not intuitive to add the new sources to a
type designation.

#30 - 04/08/2019 12:54 PM - Andreas Miiller

When having 2 type designations and the second one is not yet saved and deleting the second one both type designations are deleted but the first
shouldn't.

Don't know if this is related to this ticket. If not please open a new one or attache to another ticket.
#31 - 04/08/2019 01:34 PM - Katja Luther
Andreas Muller wrote:

When having 2 type designations and the second one is not yet saved and deleting the second one both type designations are deleted but the
first shouldn't.

Don't know if this is related to this ticket. If not please open a new one or attache to another ticket.

This is not related to this ticket, | think. | create a new ticket. (#8225)
#32 - 04/08/2019 01:46 PM - Katja Luther
Andreas Muller wrote:
If Status is completely deleted the reference is not deleted but should (similar to choosing e.g. holotype) | guess.
Also "Not designated" should be moved elsewhere to keep status and it's reference close together. Mabe we can move it down after Reference

Detail as it is not used often. (Note: we also need to check if "Not Designated" excludes other fields from being filled than we should show fields
only if "not designated" is false. But this needs further investigation)

03/20/2024 5/9


https://dev.e-taxonomy.eu/redmine/issues/8225

It would be nice to have a more specific label for reference and reference detail to make clear that it is ONLY for lectotypification. But as it is not
only for "lecto” but also for e.g. "neo" | am not sure what label to use. Maybe "Status Reference"? Any other ideas.

this is fixed.

#33 - 04/08/2019 03:39 PM - Katja Luther

Andreas Miller wrote:
After choosing a specimen for the type designation it is sometimes impossible to select the type designation to show the supplemental data for
the type designation. One needs to set the focus to something else (e.g. the taxon in name editor) and try to select the type designation again.

Also the later does not always work but difficult to reproduce.

Does someone else have the same experience? If yes, it should be fixed because otherwise it is difficult and not intuitive to add the new sources
to a type designation.

This is a little bit strange. The area where to select the typedesignation for the supplemental data view is different. when | have two typedesination
one | can click near the label of the specimen and for the other | need to click behind the type status combo (this always works!)

This is because the entitySelectionElement has a selectionListener as well and when this entitySelectionElement contains an element this element is
selected and shown in the supplemental data view.

Clicking somewhere behind the type combo or the 'Not deisgnated' checkbox activates the selection of the type designation. | think we have to

describe this in the manual because | don't know how to change this behaviour.
But maybe someone else has a better idea?

#34 - 04/09/2019 12:42 PM - Katja Luther

- Assignee changed from Katja Luther to Patrick Plitzner

Do you have an idea how to improve the selection?

#35 - 04/10/2019 02:53 PM - Andreas Miiller
2?

#36 - 04/10/2019 02:56 PM - Katja Luther

Andreas Muller wrote:

??

this was a question for Patrick. See the description in node#33

#37 - 04/10/2019 06:12 PM - Patrick Plitzner
- File picture893-1.png added

- Assignee changed from Patrick Plitzner to Katja Luther

Clicking somewhere behind the type combo or the 'Not deisgnated' checkbox activates the selection of the type designation. | think we have to
describe this in the manual because | don't know how to change this behaviour.

Changing this behaviour would require adjusting the layout of all entity selection elements and may be difficult and also may add unwanted white
space. This functionality in general is not very intuitive. In this case it is even easier because you have this large area below the right outer Delete
icon (see cursor in image). | find it even harder to select a name in the taxon details view.

@Katja: All the other issues are fixed, right? Then we may close this ticket.
#38 - 04/10/2019 10:05 PM - Andreas Miiller
Katja Luther wrote:
Andreas Miller wrote:

If Status is completely deleted the reference is not deleted but should (similar to choosing e.g. holotype) | guess.
Also "Not designated" should be moved elsewhere to keep status and it's reference close together. Mabe we can move it down after
Reference Detail as it is not used often. (Note: we also need to check if "Not Designated" excludes other fields from being filled than we
should show fields only if "not designated" is false. But this needs further investigation)
It would be nice to have a more specific label for reference and reference detail to make clear that it is ONLY for lectotypification. But as it is
not only for "lecto" but also for e.g. "neo" | am not sure what label to use. Maybe "Status Reference"? Any other ideas.

this is fixed.

Have you forgotten to push? For me it still looks like before.
#39 - 04/10/2019 10:16 PM - Andreas Miiller
Patrick Plitzner wrote:
Clicking somewhere behind the type combo or the 'Not deisgnated' checkbox activates the selection of the type designation. | think we have

to describe this in the manual because | don't know how to change this behaviour.

Changing this behaviour would require adjusting the layout of all entity selection elements and may be difficult and also may add unwanted white
space.

Why do you think so? Do you know what the reason for the behavior is? If yes please leave a note what it is. | find it strange because it often works as
expected and only sometimes it doesn't. So | don't understand why it necessarily requires complete refactoring/adjusting
This functionality in general is not very intuitive. In this case it is even easier because you have this large area below the right outer Delete icon

(see cursor in image). | find it even harder to select a name in the taxon details view.

For me this is not true, name selection always works, clicking behind (and ONLY behind) the record is less intuitive. And also: often it WORKS as
expected, only sometimes (and currently still non-deterministic) it changes the behavior and selects the specimen instead of the complete type
designation.

#40 - 04/10/2019 10:20 PM - Andreas Miiller

So not very nice (as selection is crucial for entering sources, but it is true that it always works in the area below the delete button) we may close this
ticket and create a high priority bugfix ticket once also note-28 is really fixed.

#41 - 04/11/2019 08:47 AM - Patrick Plitzner
- File picture426-1.png added
For selection the type designation you can basically select any empty space on the left or right side (see image)

However, in my case, sometimes this did not work for the first type designation. When | clicked right of the "Specimen" label | selected the specimen
(SupplementalData view updated).

When debugging this, | saw that there are always two selection change event: one for the specimen and one for the type designation. It seems like a
timing issue which one is finally selected. Disabling the selection event for the specimen selection leads to deterministic behavior. The type
designation is always selected then.

Should it be possible to select the specimen in this element?

~ Type Designations + +
Specimen Di Vincenzo, V., Kamau, P, Wondafrash, M. & | = | 2 | | | o |
Mbale, M. 339 (B AC1130). T g
Specimen Di Vincenzo, V. & Hailu, A. 204 (B AC1325). =8 |ﬁ|ﬁ|
Designation Status | Lectotype I M |
|

Reference Detail |

#42 - 04/11/2019 10:04 AM - Andreas Miiller

| just realized that the same problem exists e.g. for original sources. So it seems to be a general issue for lists, not only related specifically to type
designations. So we maybe should open a new ticket for this general issue and close this ticket as it works as expected except for the general bug.

#43 - 04/11/2019 10:10 AM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:
Andreas Miiller wrote:
If Status is completely deleted the reference is not deleted but should (similar to choosing e.g. holotype) | guess.
Also "Not designated" should be moved elsewhere to keep status and it's reference close together. Mabe we can move it down after
Reference Detail as it is not used often. (Note: we also need to check if "Not Designated" excludes other fields from being filled than
we should show fields only if "not designated" is false. But this needs further investigation)
It would be nice to have a more specific label for reference and reference detail to make clear that it is ONLY for lectotypification. But
as it is not only for "lecto” but also for e.g. "neo" | am not sure what label to use. Maybe "Status Reference"? Any other ideas.
this is fixed.

Have you forgotten to push? For me it still looks like before.

sorry, yes now, it is pushed.

#44 - 04/11/2019 10:43 AM - Andreas Miiller
- File picture499-1.png added

Now lectotype references have more space for the labels then ordinary types:
This does not look very nice and is confusing. Can it be implemented such that labels always have same width independent of type status?

#45 - 04/11/2019 10:46 AM - Andreas Muller

Maybe we shorten the "Status Reference Detail" to "Status Ref Detail" or back to "Reference Detail" (maybe with a small identation to show that it
belongs to the above reference ) or simply to Detail with a larger identation which makes it clear that it belongs to above reference.

Or we find a better technical solution.

#46 - 04/11/2019 11:30 AM - Katja Luther

- Status changed from Feedback to Resolved
Andreas Muller wrote:

Maybe we shorten the "Status Reference Detail" to "Status Ref Detail" or back to "Reference Detail" (maybe with a small identation to show that
it belongs to the above reference ) or simply to Detail with a larger identation which makes it clear that it belongs to above reference.

Or we find a better technical solution.

the status reference detail label is now "Reference Detail" again this solves the problem of the larger space for the labels. | would close this ticket and
create a follow up ticket for the remaining issues.

#47 - 04/11/2019 11:31 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller
| can not close the ticket as long as #8017 is not closed.

#48 - 04/11/2019 11:35 AM - Andreas Miiller
- Status changed from Resolved to Closed

- Assignee changed from Andreas Miiller to Katja Luther

#49 - 04/11/2019 11:35 AM - Andreas Miiller
- % Done changed from 70 to 100

Files
